#ifdef SGI
#define MAXFLOAT   1.0e99
#define NEED_32_BIT
#endif

#if defined(SUN3) || defined(SPARC)
#define NEED_32_BIT
#endif

#ifdef GENERIC
#define NEED_32_BIT
#endif

#ifdef NEED_32_BIT
/* ------------------------------------------------------------ */
/* ------------------------------------------------------------ */
/* ------------------------------------------------------------ */
/* ------------------------------------------------------------ */
/*
 *	GGGGGG EEEEEE N     N
 *	G    G E      NN    N
 *	G      E      N	N   N
 *	G   GG EEE    N	 N  N
 *	G    G E      N	  N N
 *	G    G E      N	   NN
 *	 GGGG  EEEEEE N     N
*/

/* ------------------------------------------------------------ */

#ifndef MAXFLOAT
#define MAXFLOAT 1.0e99
#endif

/* TYPES */
    /* BOOLEAN */
    /* Boolean is defined in SC.h because it is not redefinable */

    /* CHARACTER */
	typedef char				SisalCharacter;
#	define SisalMinCharacterToInteger	('\0')
#	define SisalMaxCharacterToInteger	('\177')
#	define CharacterMinVal			('\000')
#	define CharacterMaxVal			('\177')

    /* DOUBLE */
	typedef double				SisalDouble;
#	define SisalMinRealToDouble		RealMinVal
#	define SisalMaxRealToDouble		RealMaxVal
#	define DoubleMinVal			-MAXFLOAT
#	define DoubleMaxVal			MAXFLOAT
#	define SisalMinDoubleToInteger		(-2147483648.0)
#	define SisalMaxDoubleToInteger		(2147483647.0)

    /* INTEGER */
	typedef int				SisalInteger;
#	define SisalMinIntegerToCharacter ((SisalInteger)(CharacterMinVal))
#	define SisalMaxIntegerToCharacter ((SisalInteger)(CharacterMaxVal))
#	define SisalMinIntegerToDouble		IntegerMinVal
#	define SisalMaxIntegerToDouble		IntegerMaxVal
#	define SisalMinIntegerToReal		IntegerMinVal
#	define SisalMaxIntegerToReal		IntegerMaxVal
#	define IntegerMinVal			(-2147483647)
#	define IntegerMaxVal			(2147483647)

    /* NULL */
    /* NULL is defined in SC.h because it is not redefinable */

    /* REAL */
	typedef float				SisalReal;
#	define RealMinVal			-MAXFLOAT
#	define RealMaxVal			MAXFLOAT

#	define SisalMinDoubleToReal		DoubleMinVal
#	define SisalMaxDoubleToReal		DoubleMaxVal
#	define SisalMinRealToInteger		(-2147483648.0)
#	define SisalMaxRealToInteger		(2147483647.0)
/* OTHER */
#	define EndOfLine			('\n')

/* Conversions & Comparisons */
#define CharacterToLocal(val)	((char)(val))
#define LocalToCharacter(val)	((SisalCharacter)(val))

#define DoubleToLocal(val)	((double)(val))
#define LocalToDouble(val)	((SisalDouble)(val))

#define IntegerToLocal(val)	((int)(val))
#define LocalToInteger(val)	((SisalInteger)(val))
#define	IntegerZero		(0)
#define	IntegerOne		(1)
#define LocalAdd(a,b)		((a) + (b))
#define AddLocal(a,b)		((a) + (b))
#define LocalSub(a,b)		((a) - (b))
#define SubLocal(a,b)		((a) - (b))
#define IAdd(a,b)		((a) + (b))
#define ISub(a,b)		((a) - (b))
#define IMul(a,b)		((a) * (b))
#define IDiv(a,b)		((a) / (b))
#define IMod(a,b)		((a) % (b))
#define IEqual(a,b)		((a) == (b))
#define INotEqual(a,b)		((a) != (b))
#define ILess(a,b)		((a) < (b))
#define IGreat(a,b)		((a) > (b))
#define IGreatEqual(a,b)	((a) >= (b))

#define RealToLocal(val)	((float)(val))
#define LocalToReal(val)	((SisalReal)(val))

/* Required Operations */
extern void BooleanInteger();
extern void BooleanToString();
extern void CharacterEqual();
extern void CharacterInteger();
extern void CharacterLess();
extern void CharacterLessEqual();
extern void CharacterNotEqual();
extern void CharacterToString();
extern void DoubleAbs();
extern void DoubleDiv();
extern void DoubleDoubleExp();
extern void DoubleEqual();
extern void DoubleFloor();
extern void DoubleInteger();
extern void DoubleIntegerExp();
extern void DoubleLess();
extern void DoubleLessEqual();
extern void DoubleMax();
extern void DoubleMin();
extern void DoubleMinus();
extern void DoubleNeg();
extern void DoubleNotEqual();
extern void DoublePlus();
extern void DoubleReal();
extern void DoubleRealExp();
extern void DoubleTimes();
extern void DoubleToString();
extern void DoubleTrunc();
extern void IntegerAbs();
extern void IntegerBoolean();
extern void IntegerCharacter();
extern void IntegerDiv();
extern void IntegerDouble();
extern void IntegerDoubleExp();
extern void IntegerEqual();
extern void IntegerIntegerExp();
extern void IntegerLess();
extern void IntegerLessEqual();
extern void IntegerMax();
extern void IntegerMin();
extern void IntegerMinus();
extern void IntegerMod();
extern void IntegerNeg();
extern void IntegerNotEqual();
extern void IntegerPlus();
extern void IntegerReal();
extern void IntegerRealExp();
extern void IntegerTimes();
extern void IntegerToString();
extern void RealAbs();
extern void RealDiv();
extern void RealDouble();
extern void RealDoubleExp();
extern void RealEqual();
extern void RealFloor();
extern void RealInteger();
extern void RealIntegerExp();
extern void RealLess();
extern void RealLessEqual();
extern void RealMax();
extern void RealMin();
extern void RealMinus();
extern void RealNeg();
extern void RealNotEqual();
extern void RealPlus();
extern void RealRealExp();
extern void RealTimes();
extern void RealToString();
extern void RealTrunc();
extern void StringToBoolean();
extern void StringToCharacter();
extern void StringToDouble();
extern void StringToInteger();
extern void StringToReal();

#endif
